/******************************************************************************
  Copyright (c) 1996 Xerox Corporation.  All rights reserved.
  Portions of this code were written by Stephen White, aka ghond.
  Use and copying of this software and preparation of derivative works based
  upon this software are permitted.  Any distribution of this software or
  derivative works must comply with all applicable United States export
  control laws.  This software is made available AS IS, and Xerox Corporation
  makes no warranty about the software, its performance or its conformity to
  any specification.  Any person obtaining a copy of this software is requested
  to send their name and post office or electronic mail address to:
    Pavel Curtis
    Xerox PARC
    3333 Coyote Hill Rd.
    Palo Alto, CA 94304
    Pavel@Xerox.Com
 *****************************************************************************/

#include "structures.h"

extern Var new_float(double);
extern enum error become_integer(Var, int *, int);

extern int do_equals(Var, Var);
extern int compare_integers(int, int);
extern Var compare_numbers(Var, Var);

extern Var do_add(Var, Var);
extern Var do_subtract(Var, Var);
extern Var do_multiply(Var, Var);
extern Var do_divide(Var, Var);
extern Var do_modulus(Var, Var);
extern Var do_power(Var, Var);
extern Var do_shiftright(Var, Var);
extern Var do_shiftleft(Var, Var);
extern Var do_binary_and(Var, Var);
extern Var do_binary_or(Var, Var);
extern Var do_binary_xor(Var, Var);

extern const char *itoa(int n, int radix);

extern const char *base_convert_complex(const char *number, const char *src,
										const char *dest, int case_matters);
extern const char *default_base_set(int x);
extern const char *base_convert(const char *number, int src, int dest);

/* 
 * $Log: numbers.h,v $
 * Revision 1.2  2004/02/15 01:18:00  luke-jr
 * Actually add the code for it this time...
 *
 * Revision 1.1.1.1  2004/01/18 20:43:12  luke-jr
 * Initial import
 *
 * Revision 1.3  1998/12/14 13:18:38  nop
 * Merge UNSAFE_OPTS (ref fixups); fix Log tag placement to fit CVS whims
 *
 * Revision 1.2  1997/03/03 04:19:11  nop
 * GNU Indent normalization
 *
 * Revision 1.1.1.1  1997/03/03 03:45:04  nop
 * LambdaMOO 1.8.0p5
 *
 * Revision 1.1  1996/02/08  07:28:25  pavel
 * Initial revision
 *
 */
