/******************************************************************************
  Copyright (c) 1992, 1995, 1996 Xerox Corporation.  All rights reserved.
  Portions of this code were written by Stephen White, aka ghond.
  Use and copying of this software and preparation of derivative works based
  upon this software are permitted.  Any distribution of this software or
  derivative works must comply with all applicable United States export
  control laws.  This software is made available AS IS, and Xerox Corporation
  makes no warranty about the software, its performance or its conformity to
  any specification.  Any person obtaining a copy of this software is requested
  to send their name and post office or electronic mail address to:
    Pavel Curtis
    Xerox PARC
    3333 Coyote Hill Rd.
    Palo Alto, CA 94304
    Pavel@Xerox.Com
 *****************************************************************************/

#ifndef Version_H
#define Version_H 1

#include "config.h"

#define VERSION_EXPORT(vname)										\
	const char * vname ## _name;									\
	const char * vname ## _version;

VERSION_EXPORT(server)

VERSION_EXPORT(lambda_server)
VERSION_EXPORT(martian)
VERSION_EXPORT(listutils)
VERSION_EXPORT(unicode)

#undef VERSION_EXPORT

#endif				/* !Version_H */

/* 
 * $Log: version.h,v $
 * Revision 1.5  2004/02/11 00:46:32  luke-jr
 * MOO strings are now treated as UTF-8
 *
 * Revision 1.4  2004/01/31 07:35:04  luke-jr
 * Merged Database Format Selection support
 *
 * Revision 1.3  2004/01/25 04:00:10  luke-jr
 * martian/listutils juggling. Also, reformed version stuff so it's simple to add new data to version_info()
 *
 * Revision 1.2  2004/01/24 09:22:12  luke-jr
 * Updated banners to say GammaMOO and added server_name() and version_info() builtin functions. version_info() claims LambdaMOO compatibility.
 *
 * Revision 1.1.1.1  2004/01/18 20:43:13  luke-jr
 * Initial import
 *
 * Revision 1.3  1998/12/14 13:19:19  nop
 * Merge UNSAFE_OPTS (ref fixups); fix Log tag placement to fit CVS whims
 *
 * Revision 1.2  1997/03/03 04:19:39  nop
 * GNU Indent normalization
 *
 * Revision 1.1.1.1  1997/03/03 03:45:04  nop
 * LambdaMOO 1.8.0p5
 *
 * Revision 2.3  1996/04/19  01:25:21  pavel
 * Added somewhat bogus DBV_BFBugFixed version.  Release 1.8.0p4.
 *
 * Revision 2.2  1996/02/08  06:07:10  pavel
 * Added DBV_BreakCont and DBV_Float versions, check_version().  Moved
 * db_in_version to db_io.h and renamed db_out_version to current_version.
 * Updated copyright notice for 1996.  Release 1.8.0beta1.
 *
 * Revision 2.1  1995/12/28  00:48:42  pavel
 * Fixed list of new keywords in comment to remove transient `raise' keyword.
 * Release 1.8.0alpha3.
 *
 * Revision 2.0  1995/11/30  04:56:42  pavel
 * New baseline version, corresponding to release 1.8.0alpha1.
 *
 * Revision 1.3  1992/10/23  23:03:47  pavel
 * Added copyright notice.
 *
 * Revision 1.2  1992/10/21  03:02:35  pavel
 * Converted to use new automatic configuration system.
 *
 * Revision 1.1  1992/07/20  23:23:12  pavel
 * Initial RCS-controlled version.
 */
